#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

typedef struct
{
	int x;
	int y;
}
Coordonate;

typedef struct
{
	int a;
	int b;
	float m;
	int n;
}
Ecuatie;

Coordonate Tinte[20000];
Ecuatie E[20000];
long NTinte, NEcuatii;

void Citire ()
{
	ifstream fin ("poligon.in");
	int i, NDistante, D, x, yint;
	double y;
	fin >> NDistante;
	for (i=0; i<NDistante; i++)
	{
		fin >> D;
		for (x=1; x<D; x++)
		{
			y=sqrt ((double)((D*D)-(x*x)));
			yint=(int)y;
			if (y-(double)yint<0.001)
			{
				Tinte[NTinte].x=x;
				Tinte[NTinte].y=yint;
				NTinte++;
			}
		}
	}
	fin.close ();
}

void Afisare ()
{
	ofstream fout ("poligon.out");
	long i;
	fout << NTinte << "\n" << NEcuatii << "\n";
	for (i=0; i<NEcuatii; i++)
	{
		fout << E[i].n << " ";
	}
	fout << "\n";
	fout.close ();
}

void Quicksort (Ecuatie V[], long start, long end)
{
	Ecuatie Pivot, aux;
	long i, j;
	i=start;
	j=end;
	Pivot=V[(i+j)/2];
	while (i<=j)
	{
		while (V[i].m<Pivot.m)
		{
			i++;
		}
		while (V[j].m>Pivot.m)
		{
			j--;
		}
		if (i<=j)
		{
			aux=V[i];
			V[i]=V[j];
			V[j]=aux;
			i++;
			j--;
		}
	}
	if (i<end)
	{
		Quicksort (V, i, end);
	}
	if (j>start)
	{
		Quicksort (V, start, j);
	}
}

int Modul (int a)
{
	if (a<0)
	{
		return -a;
	}
	return a;
}

int CMMDC (int x, int y)
{
	while (x!=y)
	{
		if (x>y)
		{
			x=x-y;
		}
		else
		{
			y=y-x;
		}
	}
	return x;
}

Ecuatie Calcul (Coordonate P)
{
	Ecuatie ECurent;
	int cmmdc;
	ECurent.a=-P.y;
	ECurent.b=P.x;
	cmmdc=CMMDC (Modul (ECurent.a),  Modul (ECurent.b));
	ECurent.a/=cmmdc;
	ECurent.b/=cmmdc;
	ECurent.m=-(float)ECurent.a/(float)ECurent.b;
	return ECurent;
}

int main ()
{
	Ecuatie ECurent;
	long i, j, v;
	Citire ();
	for (i=0; i<NTinte; i++)
	{
		ECurent = Calcul (Tinte[i]);
		v=1;
		for (j=0; j<NEcuatii; j++)
		{
			if ((ECurent.a==E[j].a)&&(ECurent.b==E[j].b))
			{
				E[j].n++;
				v=0;
				break;
			}
		}
		if (v==1)
		{
			E[NEcuatii]=ECurent;
			E[NEcuatii].n=1;
			NEcuatii++;
		}
	}
	Quicksort (E, 0, NEcuatii-1);
	Afisare ();
	return 0;
}
