#include <fstream>
#include <cstdio>
using namespace std;

const int N=10010,K=110;
const double inf=4000000.123;
struct nod{int poz,cul,ind;} v[N];
struct asoc{int x,y;double dist;} a[K];
int n,d;
double D;

ifstream in("stalpi.in");

inline double dist(int x)
{
	return sqrt((double)(x*x+d*d));
}

inline void update(nod A,nod B)
{
	if (A.cul!=B.cul)
		return;
	double q=dist(A.poz-B.poz);
	int k=A.cul;
	if (!a[k].dist || a[k].dist>q)
	{
		D+=q;
		if (a[k].dist!=inf)
			D-=a[k].dist;
		a[k].x=A.ind;
		a[k].y=B.ind;
		a[k].dist=q;
	}
}

inline bool cmp(const nod &a,const nod &b)
{
	return a.cul<b.cul || a.cul==b.cul && a.poz<b.poz;
}

inline bool comp(nod a,nod b)
{
	return a.cul<b.cul || a.cul==b.cul && a.poz<=b.poz;
}

int bs(nod X)
{
	int i,step=1<<13;
	for (i=0;step;step>>=1)
		if (i+step<=n && comp(v[i+step],X))
			i+=step;
	return i;
}

int main()
{
	freopen("stalpi.out","w",stdout);
	int poz,i;
	nod X;
	in>>n>>d;
	for (i=1;i<=n;i++)
	{
		in>>v[i].poz>>v[i].cul;
		v[i].ind=i;
	}
	for (i=1;i<K;i++)
		a[i].dist=inf;
	sort(v+1,v+n+1,cmp);
	for (i=1;i<=n;i++)
	{
		in>>X.poz>>X.cul;
		X.ind=i;
		poz=bs(X);
		if (poz>1)
			update(v[poz-1],X);
		if (poz)
			update(v[poz],X);
		if (poz<n)
			update(v[poz+1],X);
	}
	printf("%.3lf\n",D);
	for (i=1;i<K;i++)
		if (a[i].dist!=inf)
			printf("%d %d\n",a[i].x,a[i].y);
	return 0;
}
