#include <iostream>
#include <cstdio>
#include <fstream>
#include <iomanip>
#include <cmath>

using namespace std;

typedef struct
{
	int C;
	long D;
	int i;
}
Punct;

typedef struct
{
	int C1;
	int C2;
	double D;
}
Pereche;

Punct Cablu1[10005], Cablu2[10005];
Pereche P[105];
int N, NCulori;
long D;

void Citire ()
{
	FILE *fin = fopen ("stalpi.in", "r");
	int i;
	fscanf (fin, "%d %ld", &N, &D);
	for (i=1; i<=N; i++)
	{
		fscanf (fin, "%ld %d", &Cablu1[i].D, &Cablu1[i].C);
		Cablu1[i].i=i;
		if (Cablu1[i].C>NCulori)
		{
			NCulori=Cablu1[i].C;
		}
	}
	for (i=1; i<=N; i++)
	{
		fscanf (fin, "%ld %d", &Cablu2[i].D, &Cablu2[i].C);
		Cablu2[i].i=i;
	}
	fclose (fin);
}

void Afisare ()
{
	ofstream fout ("stalpi.out");
	double S=0;
	int i, Precision=0;
	long aux;
	for (i=1; i<=NCulori; i++)
	{
		S+=sqrt(P[i].D);
	}
	aux=(long)S;
	while (aux>0)
	{
		aux/=10;
		Precision++;
	}
	fout << setprecision (Precision+3) << S << "\n";
	for (i=1; i<=NCulori; i++)
	{
		fout << Cablu1[P[i].C1].i << " " << Cablu2[P[i].C2].i << "\n";
	}
	fout.close ();
}

void Quicksort (Punct V[], int start, int end)
{
	Punct Pivot, aux;
	int i, j;
	i=start;
	j=end;
	Pivot=V[(i+j)/2];
	while (i<=j)
	{
		while (V[i].D<Pivot.D)
		{
			i++;
		}
		while (V[j].D>Pivot.D)
		{
			j--;
		}
		if (i<=j)
		{
			aux=V[i];
			V[i]=V[j];
			V[j]=aux;
			i++;
			j--;
		}
	}
	if (i<end)
	{
		Quicksort (V, i, end);
	}
	if (j>start)
	{
		Quicksort (V, start, j);
	}
}

long Calcul (long A, long B)
{
	return D*D+(A-B)*(A-B);
}

int main ()
{
	int i, j;
	long DCurent;
	Citire ();
	Quicksort (Cablu1, 1, N);
	Quicksort (Cablu2, 1, N);
	for (i=1; i<=NCulori; i++)
	{
		P[i].D=-1;
	}
	for (i=1; i<=N; i++)
	{
		for (j=1; j<=N; j++)
		{
			if (Cablu1[i].C==Cablu2[j].C)
			{
				DCurent=Calcul (Cablu1[i].D, Cablu2[j].D);
				if ((P[Cablu1[i].C].D>DCurent)||(P[Cablu1[i].C].D==-1))
				{
					P[Cablu1[i].C].D=DCurent;
					P[Cablu1[i].C].C1=i;
					P[Cablu1[i].C].C2=j;
				}
				if (Cablu1[i].D<Cablu2[i].D)
				{
					break;
				}
			}
		}
	}
	Afisare ();
	return 0;
}
