#include <cstdio>

//#define CHECK_TIME

#ifdef CHECK_TIME
#include <ctime>
#endif

const char InFile[]="tort.in";
const char OutFile[]="tort.out";
const int MaxN=512;

FILE *fin=fopen(InFile,"r");
FILE *fout=fopen(OutFile,"w");

int N,M,K,solmax,nrsol,A[MaxN][MaxN];

inline int rectsum(const int &x1, const int &y1, const int &x2, const int &y2)
{
	return A[N][M]-(A[x2][y2]-A[x2][y1-1]-A[x1-1][y2]+A[x1-1][y1-1]);
}

int main()
{
#ifdef CHECK_TIME
	int start=clock();
#endif
	
	fscanf(fin,"%d %d %d",&N,&M,&K);
	for(register int i=1;i<=N;++i)
	{
		for(register int j=1;j<=M;++j)
		{
			fscanf(fin,"%d",&A[i][j]);
			A[i][j]+=A[i-1][j]+A[i][j-1]-A[i-1][j-1];
		}
	}
	fclose(fin);
	
	for(int i=1;i<=N;++i)
	{
		for(register int j=1;j<=M;++j)
		{
			int KP=K-i-j+2;
			int x2=N-KP;
			int y2=M;
			while(x2<=N && 0<y2)
			{
				if(i<=x2 && j<=y2)
				{
					int a=rectsum(i,j,x2,y2);
					if(a>solmax)
					{
						solmax=a;
						nrsol=1;
					}
					else if(a==solmax)
					{
						++nrsol;
					}
				}
				++x2;
				--y2;
			}
		}
	}
	
	fprintf(fout,"%d\n%d",solmax,nrsol);
	fclose(fout);
	
#ifdef CHECK_TIME
	printf("%lf",(double)(clock()-start)/(double)(CLOCKS_PER_SEC));
#endif
}
